GNU Radio C++ API Reference: gr::block Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::block Class Reference
GNU Radio C++ Signal Processing Blocks » Base classes for GR Blocks

The abstract base class for all 'terminal' processing blocks. More...

`#include <gnuradio/block.h>`

## Public Types
enum | work_return_t { WORK_CALLED_PRODUCE = -2 , WORK_DONE = -1 }
| Magic return values from general_work. More...
enum | tag_propagation_policy_t { TPP_DONT = 0 , TPP_ALL_TO_ALL = 1 , TPP_ONE_TO_ONE = 2 , TPP_CUSTOM = 3 }
| enum to represent different tag propagation policies. More...

## Public Member Functions
| ~block () override
unsigned | history () const
void | set_history (unsigned history)
void | declare_sample_delay (int which, unsigned delay)
void | declare_sample_delay (unsigned delay)
unsigned | sample_delay (int which) const
bool | fixed_rate () const
| Return true if this block has a fixed input to output rate.
virtual void | forecast (int noutput_items, gr_vector_int &ninput_items_required)
| Estimate input requirements given output request.
virtual int | general_work (int noutput_items, gr_vector_int &ninput_items, gr_vector_const_void_star &input_items, gr_vector_void_star &output_items)
| compute output items from input items
virtual bool | start ()
| Called to enable drivers, etc for i/o devices.
virtual bool | stop ()
| Called to disable drivers, etc for i/o devices.
void | set_output_multiple (int multiple)
| Constrain the noutput_items argument passed to forecast and general_work.
int | output_multiple () const
bool | output_multiple_set () const
void | set_alignment (int multiple)
| Constrains buffers to work on a set item alignment (for SIMD).
int | alignment () const
void | set_unaligned (int na)
int | unaligned () const
void | set_is_unaligned (bool u)
bool | is_unaligned () const
void | consume (int which_input, int how_many_items)
| Tell the scheduler `how_many_items` of input stream `which_input` were consumed.
void | consume_each (int how_many_items)
| Tell the scheduler `how_many_items` were consumed on each input stream.
void | produce (int which_output, int how_many_items)
| Tell the scheduler `how_many_items` were produced on output stream `which_output`.
void | set_relative_rate (double relative_rate)
| Set the approximate output rate / input rate.
void | set_inverse_relative_rate (double inverse_relative_rate)
| Set the approximate output rate / input rate using its reciprocal.
void | set_relative_rate (uint64_t interpolation, uint64_t decimation)
| Set the approximate output rate / input rate as an integer ratio.
double | relative_rate () const
| return the approximate output rate / input rate
uint64_t | relative_rate_i () const
| return the numerator, or interpolation rate, of the approximate output rate / input rate
uint64_t | relative_rate_d () const
| return the denominator, or decimation rate, of the approximate output rate / input rate
mpq_class & | mp_relative_rate ()
| return a reference to the multiple precision rational representation of the approximate output rate / input rate
virtual int | fixed_rate_ninput_to_noutput (int ninput)
| Given ninput samples, return number of output samples that will be produced. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.
virtual int | fixed_rate_noutput_to_ninput (int noutput)
| Given noutput samples, return number of input samples required to produce noutput. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.
uint64_t | nitems_read (unsigned int which_input)
| Return the number of items read on input stream which_input.
uint64_t | nitems_written (unsigned int which_output)
| Return the number of items written on output stream which_output.
tag_propagation_policy_t | tag_propagation_policy ()
| Asks for the policy used by the scheduler to moved tags downstream.
void | set_tag_propagation_policy (tag_propagation_policy_t p)
| Set the policy by the scheduler to determine how tags are moved downstream.
int | min_noutput_items () const
| Return the minimum number of output items this block can produce during a call to work.
void | set_min_noutput_items (int m)
| Set the minimum number of output items this block can produce during a call to work.
int | max_noutput_items ()
| Return the maximum number of output items this block will handle during a call to work.
void | set_max_noutput_items (int m)
| Set the maximum number of output items this block will handle during a call to work.
void | unset_max_noutput_items ()
| Clear the switch for using the max_noutput_items value of this block.
bool | is_set_max_noutput_items ()
| Ask the block if the flag is or is not set to use the internal value of max_noutput_items during a call to work.
void | expand_minmax_buffer (int port)
long | max_output_buffer (size_t i)
| Returns max buffer size on output port `i`.
void | set_max_output_buffer (long max_output_buffer)
| Request limit on max buffer size on all output ports.
void | set_max_output_buffer (int port, long max_output_buffer)
| Request limit on max buffer size on output port `port`.
long | min_output_buffer (size_t i)
| Returns min buffer size on output port `i`.
void | set_min_output_buffer (long min_output_buffer)
| Request limit on the minimum buffer size on all output ports.
void | set_min_output_buffer (int port, long min_output_buffer)
| Request limit on min buffer size on output port `port`.
void | set_blkd_input_timer_value (unsigned int timer_value_ms)
| DEPRECATED Configure the timer set when input is blocked `port`.
unsigned int | blkd_input_timer_value ()
| DEPRECATED Returns timer value set when input is blocked.
void | allocate_detail (int ninputs, int noutputs, const std::vector< int > &downstream_max_nitems_vec, const std::vector< uint64_t > &downstream_lcm_nitems_vec, const std::vector< uint32_t > &downstream_max_out_mult_vec)
| Allocate the block_detail and necessary output buffers for this block.
buffer_sptr | replace_buffer (size_t src_port, size_t dst_port, block_sptr block_owner)
| Replace the block's buffer with a new one owned by the block_owner parameter.
float | pc_noutput_items ()
| Gets instantaneous noutput_items performance counter.
float | pc_noutput_items_avg ()
| Gets average noutput_items performance counter.
float | pc_noutput_items_var ()
| Gets variance of noutput_items performance counter.
float | pc_nproduced ()
| Gets instantaneous num items produced performance counter.
float | pc_nproduced_avg ()
| Gets average num items produced performance counter.
float | pc_nproduced_var ()
| Gets variance of num items produced performance counter.
float | pc_input_buffers_full (int which)
| Gets instantaneous fullness of `which` input buffer.
float | pc_input_buffers_full_avg (int which)
| Gets average fullness of `which` input buffer.
float | pc_input_buffers_full_var (int which)
| Gets variance of fullness of `which` input buffer.
std::vector< float > | pc_input_buffers_full ()
| Gets instantaneous fullness of all input buffers.
std::vector< float > | pc_input_buffers_full_avg ()
| Gets average fullness of all input buffers.
std::vector< float > | pc_input_buffers_full_var ()
| Gets variance of fullness of all input buffers.
float | pc_output_buffers_full (int which)
| Gets instantaneous fullness of `which` output buffer.
float | pc_output_buffers_full_avg (int which)
| Gets average fullness of `which` output buffer.
float | pc_output_buffers_full_var (int which)
| Gets variance of fullness of `which` output buffer.
std::vector< float > | pc_output_buffers_full ()
| Gets instantaneous fullness of all output buffers.
std::vector< float > | pc_output_buffers_full_avg ()
| Gets average fullness of all output buffers.
std::vector< float > | pc_output_buffers_full_var ()
| Gets variance of fullness of all output buffers.
float | pc_work_time ()
| Gets instantaneous clock cycles spent in work.
float | pc_work_time_avg ()
| Gets average clock cycles spent in work.
float | pc_work_time_var ()
| Gets average clock cycles spent in work.
float | pc_work_time_total ()
| Gets total clock cycles spent in work.
float | pc_throughput_avg ()
| Gets average throughput.
void | reset_perf_counters ()
| Resets the performance counters.
void | setup_pc_rpc ()
| Sets up export of perf. counters to ControlPort. Only called by the scheduler.
bool | is_pc_rpc_set () const
| Checks if this block is already exporting perf. counters to ControlPort.
void | no_pc_rpc ()
| If the block calls this in its constructor, it's perf. counters will not be exported.
void | set_processor_affinity (const std::vector< int > &mask) override
| Set the thread's affinity to processor core `n`.
void | unset_processor_affinity () override
| Remove processor affinity to a specific core.
std::vector< int > | processor_affinity () override
| Get the current processor affinity.
int | active_thread_priority ()
| Get the current thread priority in use.
int | thread_priority ()
| Get the current thread priority stored.
int | set_thread_priority (int priority)
| Set the current thread priority.
bool | update_rate () const
void | system_handler (pmt::pmt_t msg)
| the system message handler
void | set_log_level (const std::string &level) override
| Set the logger's output level.
std::string | log_level () override
| Get the logger's output level.
bool | finished ()
| returns true when execution has completed due to a message connection
block_detail_sptr | detail () const
void | set_detail (block_detail_sptr detail)
void | notify_msg_neighbors ()
| Tell msg neighbors we are finished.
void | clear_finished ()
| Make sure we don't think we are finished.
std::string | identifier () const
Public Member Functions inherited from gr::basic_block
pmt::pmt_t | message_subscribers (pmt::pmt_t port)
| ~basic_block () override
long | unique_id () const
long | symbolic_id () const
std::string | name () const
std::string | symbol_name () const
std::string | identifier () const
gr::io_signature::sptr | input_signature () const
gr::io_signature::sptr | output_signature () const
basic_block_sptr | to_basic_block ()
bool | alias_set () const
std::string | alias () const
pmt::pmt_t | alias_pmt () const
void | set_block_alias (std::string name)
void | message_port_register_in (pmt::pmt_t port_id)
void | message_port_register_out (pmt::pmt_t port_id)
void | message_port_pub (pmt::pmt_t port_id, pmt::pmt_t msg)
void | message_port_sub (pmt::pmt_t port_id, pmt::pmt_t target)
void | message_port_unsub (pmt::pmt_t port_id, pmt::pmt_t target)
virtual bool | message_port_is_hier (pmt::pmt_t port_id)
virtual bool | message_port_is_hier_in (pmt::pmt_t port_id)
virtual bool | message_port_is_hier_out (pmt::pmt_t port_id)
pmt::pmt_t | message_ports_in ()
| Get input message port names.
pmt::pmt_t | message_ports_out ()
| Get output message port names.
void | _post (pmt::pmt_t which_port, pmt::pmt_t msg)
bool | empty_p (pmt::pmt_t which_port)
| is the queue empty?
bool | empty_p ()
bool | empty_handled_p (pmt::pmt_t which_port)
| are all msg ports with handlers empty?
bool | empty_handled_p ()
size_t | nmsgs (pmt::pmt_t which_port)
| How many messages in the queue?
void | insert_tail (pmt::pmt_t which_port, pmt::pmt_t msg)
pmt::pmt_t | delete_head_nowait (pmt::pmt_t which_port)
msg_queue_t::iterator | get_iterator (pmt::pmt_t which_port)
void | erase_msg (pmt::pmt_t which_port, msg_queue_t::iterator it)
virtual bool | has_msg_port (pmt::pmt_t which_port)
const msg_queue_map_t & | get_msg_map (void) const
void | add_rpc_variable (rpcbasic_sptr s)
| Add an RPC variable (get or set).
virtual void | setup_rpc ()
| Set up the RPC registered variables.
bool | is_rpc_set ()
| Ask if this block has been registered to the RPC.
void | rpc_set ()
| When the block is registered with the RPC, set this.
virtual bool | check_topology (int ninputs, int noutputs)
| Confirm that ninputs and noutputs is an acceptable combination.
template<typename T>
void | set_msg_handler (pmt::pmt_t which_port, T msg_handler)
| Set the callback that is fired when messages are available.
Public Member Functions inherited from gr::msg_accepter
| msg_accepter ()
| ~msg_accepter () override
void | post (pmt::pmt_t which_port, pmt::pmt_t msg) override
| send `msg` to `msg_accepter` on port `which_port`
Public Member Functions inherited from gr::messages::msg_accepter
| msg_accepter ()

## Protected Member Functions
| block (void)
| block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
void | set_fixed_rate (bool fixed_rate)
void | add_item_tag (unsigned int which_output, uint64_t abs_offset, const pmt::pmt_t &key, const pmt::pmt_t &value, const pmt::pmt_t &srcid=pmt::PMT_F)
| Adds a new tag onto the given output buffer.
void | add_item_tag (unsigned int which_output, const tag_t &tag)
| Adds a new tag onto the given output buffer.
void | remove_item_tag (unsigned int which_input, uint64_t abs_offset, const pmt::pmt_t &key, const pmt::pmt_t &value, const pmt::pmt_t &srcid=pmt::PMT_F)
| DEPRECATED. Will be removed in 3.8.
void | remove_item_tag (unsigned int which_input, const tag_t &tag)
| DEPRECATED. Will be removed in 3.8.
void | get_tags_in_range (std::vector< tag_t > &v, unsigned int which_input, uint64_t abs_start, uint64_t abs_end)
| Given a [start,end), returns a vector of all tags in the range.
void | get_tags_in_range (std::vector< tag_t > &v, unsigned int which_input, uint64_t abs_start, uint64_t abs_end, const pmt::pmt_t &key)
| Given a [start,end), returns a vector of all tags in the range with a given key.
void | get_tags_in_window (std::vector< tag_t > &v, unsigned int which_input, uint64_t rel_start, uint64_t rel_end)
| Gets all tags within the relative window of the current call to work.
void | get_tags_in_window (std::vector< tag_t > &v, unsigned int which_input, uint64_t rel_start, uint64_t rel_end, const pmt::pmt_t &key)
| Operates like gr::block::get_tags_in_window with the ability to only return tags with the specified `key`.
void | enable_update_rate (bool en)
buffer_sptr | allocate_buffer (size_t port, int downstream_max_nitems, uint64_t downstream_lcm_nitems, uint32_t downstream_max_out_mult)
| Allocate a buffer for the given output port of this block. Note that the downstream max number of items must be passed in to this function for consideration.
Protected Member Functions inherited from gr::basic_block
| basic_block (void)
| basic_block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
| Protected constructor prevents instantiation by non-derived classes.
void | set_input_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_output_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_color (vcolor color)
| Allow the flowgraph to set for sorting and partitioning.
vcolor | color () const
virtual bool | has_msg_handler (pmt::pmt_t which_port)
| Tests if there is a handler attached to port `which_port`.
virtual void | dispatch_msg (pmt::pmt_t which_port, pmt::pmt_t msg)
template<typename Derived>
std::shared_ptr< Derived > | shared_from_base ()
| This is meant to be called by derived classes (e.g. block) to get a shared pointer internally. This is needed because std::enable_shared_from_this doesn't seem to work with derived classes in an inheritance hierarchy.

## Protected Attributes
std::vector< long > | d_max_output_buffer
std::vector< long > | d_min_output_buffer
unsigned int | d_blkd_input_timer_value = 250
gr::thread::mutex | d_setlock
const pmt::pmt_t | d_pmt_done
const pmt::pmt_t | d_system_port
Protected Attributes inherited from gr::basic_block
std::string | d_name
gr::io_signature::sptr | d_input_signature
gr::io_signature::sptr | d_output_signature
long | d_unique_id
long | d_symbolic_id
std::string | d_symbol_name
std::string | d_symbol_alias
vcolor | d_color
bool | d_rpc_set
gr::logger_ptr | d_logger
gr::logger_ptr | d_debug_logger
| Default logger.
msg_queue_map_t | msg_queue
| Verbose logger.
std::vector< rpcbasic_sptr > | d_rpc_vars
pmt::pmt_t | d_message_subscribers

## Additional Inherited Members
Protected Types inherited from gr::basic_block
enum | vcolor { WHITE , GREY , BLACK }

## Detailed Description

The abstract base class for all 'terminal' processing blocks.

A signal processing flow is constructed by creating a tree of hierarchical blocks, which at any level may also contain terminal nodes that actually implement signal processing functions. This is the base class for all such leaf nodes.

Blocks have a set of input streams and output streams. The input_signature and output_signature define the number of input streams and output streams respectively, and the type of the data items in each stream.

Blocks report the number of items consumed on each input in general_work(), using consume() or consume_each().

If the same number of items is produced on each output, the block returns that number from general_work(). Otherwise, the block calls produce() for each output, then returns WORK_CALLED_PRODUCE. The input and output rates are not required to be related.

User derived blocks override two methods, forecast and general_work, to implement their signal processing behavior. forecast is called by the system scheduler to determine how many items are required on each input stream in order to produce a given number of output items.

general_work is called to perform the signal processing in the block. It reads the input items and writes the output items.

## Member Enumeration Documentation

## ◆ tag_propagation_policy_t

enum gr::block::tag_propagation_policy_t

enum to represent different tag propagation policies.

Enumerator
TPP_DONT | Scheduler doesn't propagate tags from in- to output. The block itself is free to insert tags as it wants.
TPP_ALL_TO_ALL | Propagate tags from all in- to all outputs. The scheduler takes care of that.
TPP_ONE_TO_ONE | Propagate tags from n. input to n. output. Requires same number of in- and outputs
TPP_CUSTOM | Like TPP_DONT, but signals the block it should implement application-specific forwarding behaviour.

## ◆ work_return_t

enum gr::block::work_return_t

Magic return values from general_work.

Enumerator
WORK_CALLED_PRODUCE |
WORK_DONE |

## Constructor & Destructor Documentation

## ◆ ~block()

gr::block::~block | ( |  | ) |
| override

## ◆ block() [1/2]

gr::block::block | ( | void |  | ) |
| inlineprotected

## ◆ block() [2/2]

gr::block::block | ( | const std::string & | name,
|  | gr::io_signature::sptr | input_signature,
|  | gr::io_signature::sptr | output_signature )
| protected

References gr::basic_block::input_signature(), gr::basic_block::name(), and gr::basic_block::output_signature().

## Member Function Documentation

## ◆ active_thread_priority()

int gr::block::active_thread_priority | ( |  | ) |

Get the current thread priority in use.

## ◆ add_item_tag() [1/2]

void gr::block::add_item_tag | ( | unsigned int | which_output,
|  | const tag_t & | tag )
| protected

Adds a new tag onto the given output buffer.

Parameters

  which_output | an integer of which output stream to attach the tag
  tag | the tag object to add

## ◆ add_item_tag() [2/2]

void gr::block::add_item_tag | ( | unsigned int | which_output,
|  | uint64_t | abs_offset,
|  | const pmt::pmt_t & | key,
|  | const pmt::pmt_t & | value,
|  | const pmt::pmt_t & | srcid = pmt::PMT_F )
| inlineprotected

Adds a new tag onto the given output buffer.

Parameters

  which_output | an integer of which output stream to attach the tag
  abs_offset | a uint64 number of the absolute item number associated with the tag. Can get from nitems_written.
  key | the tag key as a PMT symbol
  value | any PMT holding any value for the given key
  srcid | optional source ID specifier; defaults to PMT_F

References add_item_tag(), gr::tag_t::key, gr::tag_t::offset, gr::tag_t::srcid, and gr::tag_t::value.

Referenced by add_item_tag().

## ◆ alignment()

int gr::block::alignment | ( |  | ) | const
| inline

## ◆ allocate_buffer()

buffer_sptr gr::block::allocate_buffer | ( | size_t | port,
|  | int | downstream_max_nitems,
|  | uint64_t | downstream_lcm_nitems,
|  | uint32_t | downstream_max_out_mult )
| protected

Allocate a buffer for the given output port of this block. Note that the downstream max number of items must be passed in to this function for consideration.

## ◆ allocate_detail()

void gr::block::allocate_detail | ( | int | ninputs,
|  | int | noutputs,
|  | const std::vector< int > & | downstream_max_nitems_vec,
|  | const std::vector< uint64_t > & | downstream_lcm_nitems_vec,
|  | const std::vector< uint32_t > & | downstream_max_out_mult_vec )

Allocate the block_detail and necessary output buffers for this block.

## ◆ blkd_input_timer_value()

unsigned int gr::block::blkd_input_timer_value | ( |  | ) |

DEPRECATED Returns timer value set when input is blocked.

## ◆ clear_finished()

void gr::block::clear_finished | ( |  | ) |
| inline

Make sure we don't think we are finished.

## ◆ consume()

void gr::block::consume | ( | int | which_input,
|  | int | how_many_items )

Tell the scheduler `how_many_items` of input stream `which_input` were consumed.

This function should be used in general_work() to tell the scheduler the number of input items processed. Calling consume() multiple times in the same general_work() call is safe. Every invocation of consume() updates the values returned by nitems_read().

## ◆ consume_each()

void gr::block::consume_each | ( | int | how_many_items | ) |

Tell the scheduler `how_many_items` were consumed on each input stream.

Also see notes on consume().

## ◆ declare_sample_delay() [1/2]

void gr::block::declare_sample_delay | ( | int | which,
|  | unsigned | delay )

Declares the block's delay in samples. Since the delay of blocks like filters is derived from the taps and not the block itself, we cannot automatically calculate this value and so leave it as a user-defined property. It defaults to 0 is not set.

This does not actively set the delay; it just tells the scheduler what the delay is.

This delay is mostly used to adjust the placement of the tags and is not currently used for any signal processing. When a tag is passed through a block with internal delay, its location should be moved based on the delay of the block. This interface allows us to tell the scheduler this value.

Parameters

  which | The buffer on which to set the delay.
  delay | The sample delay of the data stream.

## ◆ declare_sample_delay() [2/2]

void gr::block::declare_sample_delay | ( | unsigned | delay | ) |

Convenience wrapper to gr::block::declare_delay(int which, unsigned delay) to set all ports to the same delay.

## ◆ detail()

block_detail_sptr gr::block::detail | ( |  | ) | const
| inline

Referenced by set_detail().

## ◆ enable_update_rate()

void gr::block::enable_update_rate | ( | bool | en | ) |
| protected

## ◆ expand_minmax_buffer()

void gr::block::expand_minmax_buffer | ( | int | port | ) |

## ◆ finished()

bool gr::block::finished | ( |  | ) |

returns true when execution has completed due to a message connection

## ◆ fixed_rate()

bool gr::block::fixed_rate | ( |  | ) | const
| inline

Return true if this block has a fixed input to output rate.

If true, then fixed_rate_in_to_out and fixed_rate_out_to_in may be called.

Referenced by set_fixed_rate().

## ◆ fixed_rate_ninput_to_noutput()

virtual int gr::block::fixed_rate_ninput_to_noutput | ( | int | ninput | ) |
| virtual

Given ninput samples, return number of output samples that will be produced. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.

Reimplemented in gr::fec::decoder, gr::fec::encoder, gr::sync_block, gr::sync_decimator, and gr::sync_interpolator.

## ◆ fixed_rate_noutput_to_ninput()

virtual int gr::block::fixed_rate_noutput_to_ninput | ( | int | noutput | ) |
| virtual

Given noutput samples, return number of input samples required to produce noutput. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.

Reimplemented in gr::fec::decoder, gr::fec::encoder, gr::sync_block, gr::sync_decimator, and gr::sync_interpolator.

## ◆ forecast()

virtual void gr::block::forecast | ( | int | noutput_items,
|  | gr_vector_int & | ninput_items_required )
| virtual

Estimate input requirements given output request.

Parameters

  noutput_items | number of output items to produce
  ninput_items_required | number of input items required on each input stream

Given a request to product `noutput_items`, estimate the number of data items required on each input stream. The estimate doesn't have to be exact, but should be close.

Reimplemented in block_gateway, gr::fec::decoder, gr::fec::encoder, gr::sync_block, gr::sync_decimator, gr::sync_interpolator, and gr::tagged_stream_block.

## ◆ general_work()

virtual int gr::block::general_work | ( | int | noutput_items,
|  | gr_vector_int & | ninput_items,
|  | gr_vector_const_void_star & | input_items,
|  | gr_vector_void_star & | output_items )
| virtual

compute output items from input items

Parameters

  noutput_items | number of output items to write on each output stream
  ninput_items | number of input items available on each input stream
  input_items | vector of pointers to the input items, one entry per input stream
  output_items | vector of pointers to the output items, one entry per output stream

Returns
  number of items actually written to each output stream or WORK_CALLED_PRODUCE or WORK_DONE. It is OK to return a value less than noutput_items.

WORK_CALLED_PRODUCE is used where not all outputs produce the same number of items. general_work must call produce() for each output to indicate the number of items actually produced.

WORK_DONE indicates that no more data will be produced by this block.

general_work must call consume or consume_each to indicate how many items were consumed on each input stream.

Reimplemented in block_gateway, gr::fec::async_decoder, gr::fec::async_encoder, gr::fec::decoder, gr::fec::encoder, gr::sync_block, gr::sync_decimator, gr::sync_interpolator, gr::tagged_stream_block, and gr::uhd::rfnoc_block.

## ◆ get_tags_in_range() [1/2]

void gr::block::get_tags_in_range | ( | std::vector< tag_t > & | v,
|  | unsigned int | which_input,
|  | uint64_t | abs_start,
|  | uint64_t | abs_end )
| protected

Given a [start,end), returns a vector of all tags in the range.

Range of counts is from start to end-1.

Tags are tuples of: (item count, source id, key, value)

Parameters

  v | a vector reference to return tags into
  which_input | an integer of which input stream to pull from
  abs_start | a uint64 count of the start of the range of interest
  abs_end | a uint64 count of the end of the range of interest

## ◆ get_tags_in_range() [2/2]

void gr::block::get_tags_in_range | ( | std::vector< tag_t > & | v,
|  | unsigned int | which_input,
|  | uint64_t | abs_start,
|  | uint64_t | abs_end,
|  | const pmt::pmt_t & | key )
| protected

Given a [start,end), returns a vector of all tags in the range with a given key.

Range of counts is from start to end-1.

Tags are tuples of: (item count, source id, key, value)

Parameters

  v | a vector reference to return tags into
  which_input | an integer of which input stream to pull from
  abs_start | a uint64 count of the start of the range of interest
  abs_end | a uint64 count of the end of the range of interest
  key | a PMT symbol key to filter only tags of this key

## ◆ get_tags_in_window() [1/2]

void gr::block::get_tags_in_window | ( | std::vector< tag_t > & | v,
|  | unsigned int | which_input,
|  | uint64_t | rel_start,
|  | uint64_t | rel_end )
| protected

Gets all tags within the relative window of the current call to work.

This operates much like get_tags_in_range but allows us to work within the current window of items. Item range is therefore within the possible range of 0 to ninput_items[whic_input].

Range of items counts from `rel_start` to `rel_end-1` within current window.

Tags are tuples of: (item count, source id, key, value)

Parameters

  v | a vector reference to return tags into
  which_input | an integer of which input stream to pull from
  rel_start | a uint64 count of the start of the range of interest
  rel_end | a uint64 count of the end of the range of interest

## ◆ get_tags_in_window() [2/2]

void gr::block::get_tags_in_window | ( | std::vector< tag_t > & | v,
|  | unsigned int | which_input,
|  | uint64_t | rel_start,
|  | uint64_t | rel_end,
|  | const pmt::pmt_t & | key )
| protected

Operates like gr::block::get_tags_in_window with the ability to only return tags with the specified `key`.

Parameters

  v | a vector reference to return tags into
  which_input | an integer of which input stream to pull from
  rel_start | a uint64 count of the start of the range of interest
  rel_end | a uint64 count of the end of the range of interest
  key | a PMT symbol key to filter only tags of this key

## ◆ history()

unsigned gr::block::history | ( |  | ) | const

Assume block computes y_i = f(x_i, x_i-1, x_i-2, x_i-3...) History is the number of x_i's that are examined to produce one y_i. This comes in handy for FIR filters, where we use history to ensure that our input contains the appropriate "history" for the filter. History should be equal to the number of filter taps. First history samples (when there are no previous samples) are initialized with zeroes.

Referenced by gr::blocks::host_buffer_copy::make(), and set_history().

## ◆ identifier()

std::string gr::block::identifier | ( |  | ) | const

## ◆ is_pc_rpc_set()

bool gr::block::is_pc_rpc_set | ( |  | ) | const
| inline

Checks if this block is already exporting perf. counters to ControlPort.

## ◆ is_set_max_noutput_items()

bool gr::block::is_set_max_noutput_items | ( |  | ) |

Ask the block if the flag is or is not set to use the internal value of max_noutput_items during a call to work.

## ◆ is_unaligned()

bool gr::block::is_unaligned | ( |  | ) | const
| inline

## ◆ log_level()

std::string gr::block::log_level | ( |  | ) |
| overridevirtual

Get the logger's output level.

Implements gr::basic_block.

Referenced by gr::blocks::message_debug::make(), and gr::blocks::message_debug::set_level().

## ◆ max_noutput_items()

int gr::block::max_noutput_items | ( |  | ) |

Return the maximum number of output items this block will handle during a call to work.

## ◆ max_output_buffer()

long gr::block::max_output_buffer | ( | size_t | i | ) |

Returns max buffer size on output port `i`.

Referenced by set_max_output_buffer(), and set_max_output_buffer().

## ◆ min_noutput_items()

int gr::block::min_noutput_items | ( |  | ) | const
| inline

Return the minimum number of output items this block can produce during a call to work.

Should be 0 for most blocks. Useful if we're dealing with packets and the block produces one packet per call to work.

## ◆ min_output_buffer()

long gr::block::min_output_buffer | ( | size_t | i | ) |

Returns min buffer size on output port `i`.

Referenced by set_min_output_buffer(), and set_min_output_buffer().

## ◆ mp_relative_rate()

mpq_class & gr::block::mp_relative_rate | ( |  | ) |
| inline

return a reference to the multiple precision rational representation of the approximate output rate / input rate

## ◆ nitems_read()

uint64_t gr::block::nitems_read | ( | unsigned int | which_input | ) |

Return the number of items read on input stream which_input.

## ◆ nitems_written()

uint64_t gr::block::nitems_written | ( | unsigned int | which_output | ) |

Return the number of items written on output stream which_output.

## ◆ no_pc_rpc()

void gr::block::no_pc_rpc | ( |  | ) |
| inline

If the block calls this in its constructor, it's perf. counters will not be exported.

## ◆ notify_msg_neighbors()

void gr::block::notify_msg_neighbors | ( |  | ) |

Tell msg neighbors we are finished.

## ◆ output_multiple()

int gr::block::output_multiple | ( |  | ) | const
| inline

## ◆ output_multiple_set()

bool gr::block::output_multiple_set | ( |  | ) | const
| inline

## ◆ pc_input_buffers_full() [1/2]

std::vector< float > gr::block::pc_input_buffers_full | ( |  | ) |

Gets instantaneous fullness of all input buffers.

## ◆ pc_input_buffers_full() [2/2]

float gr::block::pc_input_buffers_full | ( | int | which | ) |

Gets instantaneous fullness of `which` input buffer.

## ◆ pc_input_buffers_full_avg() [1/2]

std::vector< float > gr::block::pc_input_buffers_full_avg | ( |  | ) |

Gets average fullness of all input buffers.

## ◆ pc_input_buffers_full_avg() [2/2]

float gr::block::pc_input_buffers_full_avg | ( | int | which | ) |

Gets average fullness of `which` input buffer.

## ◆ pc_input_buffers_full_var() [1/2]

std::vector< float > gr::block::pc_input_buffers_full_var | ( |  | ) |

Gets variance of fullness of all input buffers.

## ◆ pc_input_buffers_full_var() [2/2]

float gr::block::pc_input_buffers_full_var | ( | int | which | ) |

Gets variance of fullness of `which` input buffer.

## ◆ pc_noutput_items()

float gr::block::pc_noutput_items | ( |  | ) |

Gets instantaneous noutput_items performance counter.

## ◆ pc_noutput_items_avg()

float gr::block::pc_noutput_items_avg | ( |  | ) |

Gets average noutput_items performance counter.

## ◆ pc_noutput_items_var()

float gr::block::pc_noutput_items_var | ( |  | ) |

Gets variance of noutput_items performance counter.

## ◆ pc_nproduced()

float gr::block::pc_nproduced | ( |  | ) |

Gets instantaneous num items produced performance counter.

## ◆ pc_nproduced_avg()

float gr::block::pc_nproduced_avg | ( |  | ) |

Gets average num items produced performance counter.

## ◆ pc_nproduced_var()

float gr::block::pc_nproduced_var | ( |  | ) |

Gets variance of num items produced performance counter.

## ◆ pc_output_buffers_full() [1/2]

std::vector< float > gr::block::pc_output_buffers_full | ( |  | ) |

Gets instantaneous fullness of all output buffers.

## ◆ pc_output_buffers_full() [2/2]

float gr::block::pc_output_buffers_full | ( | int | which | ) |

Gets instantaneous fullness of `which` output buffer.

## ◆ pc_output_buffers_full_avg() [1/2]

std::vector< float > gr::block::pc_output_buffers_full_avg | ( |  | ) |

Gets average fullness of all output buffers.

## ◆ pc_output_buffers_full_avg() [2/2]

float gr::block::pc_output_buffers_full_avg | ( | int | which | ) |

Gets average fullness of `which` output buffer.

## ◆ pc_output_buffers_full_var() [1/2]

std::vector< float > gr::block::pc_output_buffers_full_var | ( |  | ) |

Gets variance of fullness of all output buffers.

## ◆ pc_output_buffers_full_var() [2/2]

float gr::block::pc_output_buffers_full_var | ( | int | which | ) |

Gets variance of fullness of `which` output buffer.

## ◆ pc_throughput_avg()

float gr::block::pc_throughput_avg | ( |  | ) |

Gets average throughput.

## ◆ pc_work_time()

float gr::block::pc_work_time | ( |  | ) |

Gets instantaneous clock cycles spent in work.

## ◆ pc_work_time_avg()

float gr::block::pc_work_time_avg | ( |  | ) |

Gets average clock cycles spent in work.

## ◆ pc_work_time_total()

float gr::block::pc_work_time_total | ( |  | ) |

Gets total clock cycles spent in work.

## ◆ pc_work_time_var()

float gr::block::pc_work_time_var | ( |  | ) |

Gets average clock cycles spent in work.

## ◆ processor_affinity()

std::vector< int > gr::block::processor_affinity | ( |  | ) |
| inlineoverridevirtual

Get the current processor affinity.

Implements gr::basic_block.

## ◆ produce()

void gr::block::produce | ( | int | which_output,
|  | int | how_many_items )

Tell the scheduler `how_many_items` were produced on output stream `which_output`.

This function should be used in general_work() to tell the scheduler the number of output items produced. If produce() is called in general_work(), general_work() must return `WORK_CALLED_PRODUCE`. Calling produce() multiple times in the same general_work() call is safe. Every invocation of produce() updates the values returned by nitems_written().

## ◆ relative_rate()

double gr::block::relative_rate | ( |  | ) | const
| inline

return the approximate output rate / input rate

Referenced by gr::blocks::file_meta_sink::make(), and set_relative_rate().

## ◆ relative_rate_d()

uint64_t gr::block::relative_rate_d | ( |  | ) | const
| inline

return the denominator, or decimation rate, of the approximate output rate / input rate

## ◆ relative_rate_i()

uint64_t gr::block::relative_rate_i | ( |  | ) | const
| inline

return the numerator, or interpolation rate, of the approximate output rate / input rate

## ◆ remove_item_tag() [1/2]

void gr::block::remove_item_tag | ( | unsigned int | which_input,
|  | const tag_t & | tag )
| protected

DEPRECATED. Will be removed in 3.8.

Parameters

  which_input | an integer of which input stream to remove the tag from
  tag | the tag object to remove

## ◆ remove_item_tag() [2/2]

void gr::block::remove_item_tag | ( | unsigned int | which_input,
|  | uint64_t | abs_offset,
|  | const pmt::pmt_t & | key,
|  | const pmt::pmt_t & | value,
|  | const pmt::pmt_t & | srcid = pmt::PMT_F )
| inlineprotected

DEPRECATED. Will be removed in 3.8.

Parameters

  which_input | an integer of which input stream to remove the tag from
  abs_offset | a uint64 number of the absolute item number associated with the tag. Can get from nitems_written.
  key | the tag key as a PMT symbol
  value | any PMT holding any value for the given key
  srcid | optional source ID specifier; defaults to PMT_F

If no such tag is found, does nothing.

References gr::tag_t::key, gr::tag_t::offset, remove_item_tag(), gr::tag_t::srcid, and gr::tag_t::value.

Referenced by remove_item_tag().

## ◆ replace_buffer()

buffer_sptr gr::block::replace_buffer | ( | size_t | src_port,
|  | size_t | dst_port,
|  | block_sptr | block_owner )

Replace the block's buffer with a new one owned by the block_owner parameter.

This function is used to replace the buffer on the specified output port of the block with a new buffer that is "owned" by the specified block. This function will only be called if a downstream block is using a custom buffer that is incompatible with the default buffer type created by this block.

## ◆ reset_perf_counters()

void gr::block::reset_perf_counters | ( |  | ) |

Resets the performance counters.

## ◆ sample_delay()

unsigned gr::block::sample_delay | ( | int | which | ) | const

Gets the delay of the block. Since the delay of blocks like filters is derived from the taps and not the block itself, we cannot automatically calculate this value and so leave it as a user-defined property. It defaults to 0 is not set.

Parameters

  which | Which port from which to get the sample delay.

## ◆ set_alignment()

void gr::block::set_alignment | ( | int | multiple | ) |

Constrains buffers to work on a set item alignment (for SIMD).

set_alignment_multiple causes the scheduler to ensure that the noutput_items argument passed to forecast and general_work will be an integer multiple of

Parameters

  multiple | The default value is 1.

This control is similar to the output_multiple setting, except that if the number of items passed to the block is less than the output_multiple, this value is ignored and the block can produce like normal. The d_unaligned value is set to the number of items the block is off by. In the next call to general_work, the noutput_items is set to d_unaligned or less until d_unaligned==0. The buffers are now aligned again and the aligned calls can be performed again.

## ◆ set_blkd_input_timer_value()

void gr::block::set_blkd_input_timer_value | ( | unsigned int | timer_value_ms | ) |

DEPRECATED Configure the timer set when input is blocked `port`.

This is an advanced/experimental feature and might be removed in a future version. Calling this can affect some fundamental assumptions about the system behavior and performance.

In the TPB scheduler, when a block has no work to do because there is no data at it inputs, it sets a timer and tries again after a period of time. The default is 250 ms, but this can be configured differently per block when necessary

Parameters

  timer_value_ms | the timer value in milliseconds

## ◆ set_detail()

void gr::block::set_detail | ( | block_detail_sptr | detail | ) |
| inline

References detail().

## ◆ set_fixed_rate()

void gr::block::set_fixed_rate | ( | bool | fixed_rate | ) |
| inlineprotected

References fixed_rate().

## ◆ set_history()

void gr::block::set_history | ( | unsigned | history | ) |

References history().

## ◆ set_inverse_relative_rate()

void gr::block::set_inverse_relative_rate | ( | double | inverse_relative_rate | ) |

Set the approximate output rate / input rate using its reciprocal.

This is a convenience function to avoid numerical problems with tag propagation that calling set_relative_rate(1.0/relative_rate) might introduce.

## ◆ set_is_unaligned()

void gr::block::set_is_unaligned | ( | bool | u | ) |

## ◆ set_log_level()

void gr::block::set_log_level | ( | const std::string & | level | ) |
| overridevirtual

Set the logger's output level.

Sets the level of the logger. This takes a string that is translated to the standard levels and can be (case insensitive):

- off , notset
- debug
- info
- notice
- warn
- error
- crit
- alert
- fatal
- emerg

Implements gr::basic_block.

## ◆ set_max_noutput_items()

void gr::block::set_max_noutput_items | ( | int | m | ) |

Set the maximum number of output items this block will handle during a call to work.

Parameters

  m | the maximum noutput_items this block will handle.

## ◆ set_max_output_buffer() [1/2]

void gr::block::set_max_output_buffer | ( | int | port,
|  | long | max_output_buffer )

Request limit on max buffer size on output port `port`.

This is an advanced feature. Calling this can affect some fundamental assumptions about the system behavior and performance.

The actual buffer size is determined by a number of other factors from the block and system. This function only provides a requested maximum. The buffers will always be a multiple of the system page size, which may be larger than the value asked for here.

Parameters

  port | the output port the request applies to.
  max_output_buffer | the requested maximum output size in items.

References max_output_buffer().

## ◆ set_max_output_buffer() [2/2]

void gr::block::set_max_output_buffer | ( | long | max_output_buffer | ) |

Request limit on max buffer size on all output ports.

This is an advanced feature. Calling this can affect some fundamental assumptions about the system behavior and performance.

The actual buffer size is determined by a number of other factors from the block and system. This function only provides a requested maximum. The buffers will always be a multiple of the system page size, which may be larger than the value asked for here.

Parameters

  max_output_buffer | the requested maximum output size in items.

References max_output_buffer().

## ◆ set_min_noutput_items()

void gr::block::set_min_noutput_items | ( | int | m | ) |
| inline

Set the minimum number of output items this block can produce during a call to work.

Parameters

  m | the minimum noutput_items this block can produce.

## ◆ set_min_output_buffer() [1/2]

void gr::block::set_min_output_buffer | ( | int | port,
|  | long | min_output_buffer )

Request limit on min buffer size on output port `port`.

This is an advanced feature. Calling this can affect some fundamental assumptions about the system behavior and performance.

The actual buffer size is determined by a number of other factors from the block and system. This function only provides a requested minimum. The buffers will always be a multiple of the system page size, which may be larger than the value asked for here.

Parameters

  port | the output port the request applies to.
  min_output_buffer | the requested minimum output size in items.

References min_output_buffer().

## ◆ set_min_output_buffer() [2/2]

void gr::block::set_min_output_buffer | ( | long | min_output_buffer | ) |

Request limit on the minimum buffer size on all output ports.

This is an advanced feature. Calling this can affect some fundamental assumptions about the system behavior and performance.

The actual buffer size is determined by a number of other factors from the block and system. This function only provides a requested minimum. The buffers will always be a multiple of the system page size, which may be larger than the value asked for here.

Parameters

  min_output_buffer | the requested minimum output size in items.

References min_output_buffer().

## ◆ set_output_multiple()

void gr::block::set_output_multiple | ( | int | multiple | ) |

Constrain the noutput_items argument passed to forecast and general_work.

set_output_multiple causes the scheduler to ensure that the noutput_items argument passed to forecast and general_work will be an integer multiple of

Parameters

  multiple | The default value of output multiple is 1.

Referenced by gr::sync_interpolator::set_interpolation().

## ◆ set_processor_affinity()

void gr::block::set_processor_affinity | ( | const std::vector< int > & | mask | ) |
| overridevirtual

Set the thread's affinity to processor core `n`.

Parameters

  mask | a vector of ints of the core numbers available to this block.

Implements gr::basic_block.

## ◆ set_relative_rate() [1/2]

void gr::block::set_relative_rate | ( | double | relative_rate | ) |

Set the approximate output rate / input rate.

Provide a hint to the buffer allocator and scheduler. The default relative_rate is 1.0

decimators have relative_rates < 1.0 interpolators have relative_rates > 1.0

References relative_rate().

Referenced by gr::sync_decimator::set_decimation(), and gr::sync_interpolator::set_interpolation().

## ◆ set_relative_rate() [2/2]

void gr::block::set_relative_rate | ( | uint64_t | interpolation,
|  | uint64_t | decimation )

Set the approximate output rate / input rate as an integer ratio.

Provide a hint to the buffer allocator and scheduler. The default relative_rate is interpolation / decimation = 1 / 1

decimators have relative_rates < 1.0 interpolators have relative_rates > 1.0

## ◆ set_tag_propagation_policy()

void gr::block::set_tag_propagation_policy | ( | tag_propagation_policy_t | p | ) |

Set the policy by the scheduler to determine how tags are moved downstream.

## ◆ set_thread_priority()

int gr::block::set_thread_priority | ( | int | priority | ) |

Set the current thread priority.

## ◆ set_unaligned()

void gr::block::set_unaligned | ( | int | na | ) |

## ◆ setup_pc_rpc()

void gr::block::setup_pc_rpc | ( |  | ) |

Sets up export of perf. counters to ControlPort. Only called by the scheduler.

## ◆ start()

virtual bool gr::block::start | ( |  | ) |
| virtual

Called to enable drivers, etc for i/o devices.

This allows a block to enable an associated driver to begin transferring data just before we start to execute the scheduler. The end result is that this reduces latency in the pipeline when dealing with audio devices, usrps, etc.

Reimplemented in block_gateway, and gr::blocks::probe_rate.

Referenced by gr::qtgui::vector_sink_f::set_x_axis(), gr::qtgui::time_raster_sink_b::set_x_range(), gr::qtgui::time_raster_sink_f::set_x_range(), gr::qtgui::time_raster_sink_b::set_y_range(), and gr::qtgui::time_raster_sink_f::set_y_range().

## ◆ stop()

virtual bool gr::block::stop | ( |  | ) |
| virtual

Called to disable drivers, etc for i/o devices.

Reimplemented in block_gateway, and gr::blocks::probe_rate.

## ◆ system_handler()

void gr::block::system_handler | ( | pmt::pmt_t | msg | ) |

the system message handler

## ◆ tag_propagation_policy()

tag_propagation_policy_t gr::block::tag_propagation_policy | ( |  | ) |

Asks for the policy used by the scheduler to moved tags downstream.

Referenced by gr::blocks::multiply_matrix< float >::make().

## ◆ thread_priority()

int gr::block::thread_priority | ( |  | ) |

Get the current thread priority stored.

## ◆ unaligned()

int gr::block::unaligned | ( |  | ) | const
| inline

## ◆ unset_max_noutput_items()

void gr::block::unset_max_noutput_items | ( |  | ) |

Clear the switch for using the max_noutput_items value of this block.

When is_set_max_noutput_items() returns 'true', the scheduler will use the value returned by max_noutput_items() to limit the size of the number of items possible for this block's work function. If is_set_max_notput_items() returns 'false', then the scheduler ignores the internal value and uses the value set globally in the top_block.

Use this value to clear the 'is_set' flag so the scheduler will ignore this. Use the set_max_noutput_items(m) call to both set a new value for max_noutput_items and to re-enable its use in the scheduler.

## ◆ unset_processor_affinity()

void gr::block::unset_processor_affinity | ( |  | ) |
| overridevirtual

Remove processor affinity to a specific core.

Implements gr::basic_block.

## ◆ update_rate()

bool gr::block::update_rate | ( |  | ) | const

## Member Data Documentation

## ◆ d_blkd_input_timer_value

unsigned int gr::block::d_blkd_input_timer_value = 250
| protected

## ◆ d_max_output_buffer

std::vector<long> gr::block::d_max_output_buffer
| protected

## ◆ d_min_output_buffer

std::vector<long> gr::block::d_min_output_buffer
| protected

## ◆ d_pmt_done

const pmt::pmt_t gr::block::d_pmt_done
| protected

PMT Symbol for "hey, we're done here"

## ◆ d_setlock

gr::thread::mutex gr::block::d_setlock
| mutableprotected

Used by block's setters and work functions to make setting/resetting of parameters thread-safe.

Used by calling gr::thread::scoped_lock l(d_setlock);

## ◆ d_system_port

const pmt::pmt_t gr::block::d_system_port
| protected

PMT Symbol of the system port, pmt::mp("system")

The documentation for this class was generated from the following file:

- gnuradio-runtime/include/gnuradio/block.h